#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
typedef tree<pair<int, int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int N = 1e5 + 5;
int sum[4 * N], mx[4 * N], a[N], p[4 * N], sum1[4 * N], mx1[4 * N];

void build(int v,int l,int r) {
    if (l == r) {
        mx[v] = l;
        sum[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m + 1, r);
    if (a[mx[2 * v]] > a[mx[2 * v + 1]]) mx[v] = mx[2 * v];
    else mx[v] = mx[2 * v + 1];
    sum[v] = sum[v * 2] + sum[v * 2 + 1];
}

int gmx(int v,int l,int r,int l1,int r1) {
    if (l >= l1 && r <= r1) {
        return mx[v];
    }
    if (l > r1 || r < l1) {
        return -1;
    }
    int m = (l + r) / 2;
    int q = gmx(v * 2, l, m, l1, r1);
    int w = gmx(v * 2 + 1, m + 1, r, l1, r1);
    if (w == -1 || a[q] > a[w] && q != -1) return q;
    else return w;
}

void push(int v) {
    p[2 * v] = max(p[2 * v], p[v]);
    p[2 * v + 1] = max(p[2 * v + 1], p[v]);
}

void upd(int v,int l,int r,int l1,int r1,int x) {
    if (l >= l1 && r <= r1) {
        p[v] = max(p[v], x);
        push(v);
        return;
    }
    if (l > r1 || r < l1) return;
    int m = (l + r) / 2;
    upd(v * 2, l, m, l1, r1, x);
    upd(v * 2 + 1, m + 1, r, l1, r1, x);
}

int gsum(int v,int l,int r,int l1,int r1) {
    if (l >= l1 && r <= r1) {
        return sum[v];
    }
    if (l > r1 || r < l1) {
        return 0;
    }
    int m = (l + r) / 2;
    return gsum(v * 2, l, m, l1, r1) + gsum(v * 2 + 1, m + 1, r, l1, r1);
}

signed main() {
    int n, m, i, j;
    ordered_set os;
    cin >> n;
    for (i = 0; i < n; i++)cin >> a[i];
    build(1, 0, n - 1);
    for (i = 0; i < n; i++)os.insert({i, i});
    for (i = 0; i < n - 1; i++) {
        int x;
        cin >> x;
        auto it = os.find_by_order(x - 1);
        auto p1 = *it;
        ++it;
        auto p2 = *it;
        int q = gmx(1, 0, n - 1, p1.first, p1.second);
        int w = gmx(1, 0, n - 1, p2.first, p2.second);
        int e = min(a[q], a[w]);
        q++;
        w--;
        int ans = max(0ll,e * (w - q + 1) - gsum(1, 0, n - 1, q, w));
        int mx1 = 0;
        for (j = p1.first; j < q - 1; j++) {
            mx1 = max(mx1, a[j]);
            ans += mx1 - a[j];
        }
        mx1 = 0;
        for (j = p2.second; j > w + 1; j--) {
            mx1 = max(mx1, a[j]);
            ans += mx1 - a[j];
        }
        cout << ans << "\n";
        os.erase(p1);
        os.erase(p2);
        os.insert({p1.first, p2.second});
    }
    return 0;
}
